Loading...
Searching...
No Matches
casacore::TSMCube Class Reference
tables package (libcasa_tables) » DataMan_module » DataMan_module_internal_classes

More...

`#include <TSMCube.h>`

## Public Types

enum | AccessType { NoAccess , CellAccess , SliceAccess , ColumnAccess , ColumnSliceAccess }
| Define the possible access types for TSMDataColumn. More...

## Public Member Functions

| TSMCube (TiledStMan *stman, TSMFile *file, const IPosition &cubeShape, const IPosition &tileShape, const Record &values, Int64 fileOffset, Bool useDerived=False)
| Construct the hypercube using the given file with the given shape.
| TSMCube (TiledStMan *stman, AipsIO &ios, Bool useDerived=False)
| Reconstruct the hypercube by reading its data from the AipsIO stream.
virtual | ~TSMCube ()
| TSMCube (const TSMCube &)=delete
| Forbid copy constructor.
TSMCube & | operator= (const TSMCube &)=delete
| Forbid assignment.
virtual void | flushCache ()
| Flush the data in the cache.
void | clearCache (Bool doFlush=True)
| Clear the cache, so data will be reread.
void | emptyCache ()
| Empty the cache.
virtual void | showCacheStatistics (ostream &os) const
| Show the cache statistics.
void | putObject (AipsIO &ios)
| Put the data of the object into the AipsIO stream.
Int | getObject (AipsIO &ios)
| Get the data of the object from the AipsIO stream.
virtual void | resync (AipsIO &ios)
| Resync the object with the data file.
Bool | isExtensible () const
| Is the hypercube extensible?
uInt | bucketSize () const
| Get the bucket size (bytes).
uInt | localTileLength () const
| Get the length of a tile (in bytes) in local format.
virtual void | setShape (const IPosition &cubeShape, const IPosition &tileShape)
| Set the hypercube shape.
const IPosition & | cubeShape () const
| Get the shape of the hypercube.
const IPosition & | tileShape () const
| Get the shape of the tiles.
IPosition | cellShape () const
| Get the shape of the data cells in the cube.
uInt | coordinateSize (const String &coordinateName) const
| Get the size of a coordinate (i.e.
const Record & | valueRecord () const
| Get the record containing the id and coordinate values.
Record & | rwValueRecord ()
Bool | matches (const PtrBlock< TSMColumn * > &idColSet, const Record &idValues)
| Test if the id values match.
virtual void | extend (uInt64 nr, const Record &coordValues, const TSMColumn *lastCoordColumn)
| Extend the last dimension of the cube with the given number.
void | extendCoordinates (const Record &coordValues, const String &coordName, uInt length)
| Extend the coordinates vector for the given coordinate to the given length with the given coordValues.
virtual void | accessSection (const IPosition &start, const IPosition &end, char *section, uInt colnr, uInt localPixelSize, uInt externalPixelSize, Bool writeFlag)
| Read or write a section in the cube.
virtual void | accessStrided (const IPosition &start, const IPosition &end, const IPosition &stride, char *section, uInt colnr, uInt localPixelSize, uInt externalPixelSize, Bool writeFlag)
| Read or write a section in a strided way.
uInt | cacheSize () const
| Get the current cache size (in buckets).
uInt | calcCacheSize (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath) const
| Calculate the cache size (in buckets) for the given slice and access path.
virtual void | setCacheSize (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath, Bool forceSmaller, Bool userSet)
| Set the cache size for the given slice and access path.
virtual void | setCacheSize (uInt cacheSize, Bool forceSmaller, Bool userSet)
| Resize the cache object.
uInt | validateCacheSize (uInt cacheSize) const
| Validate the cache size (in buckets).
Bool | userSetCache () const
| Determine if the user set the cache size (using setCacheSize).
AccessType | getLastColAccess () const
| Functions for TSMDataColumn to keep track of the last type of access to a hypercube.
const IPosition & | getLastColSlice () const
void | setLastColAccess (AccessType type)
void | setLastColSlice (const IPosition &slice)

## Static Public Member Functions

static uInt | calcCacheSize (const IPosition &cubeShape, const IPosition &tileShape, Bool extensible, const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath, uInt maxCacheSizeMiB, uInt bucketSize)
static uInt | validateCacheSize (uInt cacheSize, uInt maxSizeMiB, uInt bucketSize)

## Protected Member Functions

void | setup ()
| Initialize the various variables.
void | setupNrTiles ()
IPosition | adjustTileShape (const IPosition &cubeShape, const IPosition &tileShape) const
| Adjust the tile shape to the hypercube shape.
void | resizeTileSections ()
| Resize the IPosition member variables used in accessSection() if nrdim_p changes value.

## Protected Attributes

char * | cachedTile_p
TiledStMan * | stmanPtr_p
| Pointer to the parent storage manager.
Bool | useDerived_p
| Is the class used directly or only by a derived class only?
Record | values_p
| The values of the possible id and coordinate columns.
Bool | extensible_p
| Is the hypercube extensible?
uInt | nrdim_p
| Dimensionality of the hypercube.
uInt | nrTiles_p
| Number of tiles in the hypercube.
IPosition | cubeShape_p
| The shape of the hypercube.
IPosition | tileShape_p
| The shape of the tiles in the hypercube.
IPosition | tilesPerDim_p
| The number of tiles in each hypercube dimension.
TSMShape | expandedTileShape_p
| Precomputed tileShape information.
TSMShape | expandedTilesPerDim_p
| Precomputed tilesPerDim information.
uInt | nrTilesSubCube_p
| Number of tiles in all but last dimension (used when extending).
uInt | tileSize_p
| The tilesize in bytes.
TSMFile * | filePtr_p
| Pointer to the TSMFile object holding the data.
Int64 | fileOffset_p
| Offset in the TSMFile object where the data of this hypercube starts.
Block< uInt > | externalOffset_p
| Offset for each data column in a tile (in external format).
Block< uInt > | localOffset_p
| Offset for each data column in a tile (in local format).
uInt | bucketSize_p
| The bucket size in bytes (is equal to tile size in bytes).
uInt | localTileLength_p
| The tile size in bytes in local format.
BucketCache * | cache_p
| The bucket cache.
Bool | userSetCache_p
| Did the user set the cache size?
AccessType | lastColAccess_p
| Was the last column access to a cell, slice, or column?
IPosition | lastColSlice_p
| The slice shape of the last column access to a slice.
IPosition | nrTileSection_p
| IPosition variables used in accessSection(); declared here as member variables to avoid significant construction and desctruction overhead if they are local to accessSection() #tiles needed for the section.
IPosition | startTile_p
| First tile needed.
IPosition | endTile_p
| Last tile needed.
IPosition | startPixelInFirstTile_p
| First pixel in first tile.
IPosition | endPixelInFirstTile_p
| Last pixel in first tile.
IPosition | endPixelInLastTile_p
| Last pixel in last tile.

## Private Member Functions

BucketCache * | getCache ()
| Get the cache object.
virtual void | makeCache ()
| Construct the cache object (if not constructed yet).
virtual void | resyncCache ()
| Resync the cache object.
virtual void | deleteCache ()
| Delete the cache object.
void | accessLine (char *section, uInt pixelOffset, uInt localPixelSize, Bool writeFlag, BucketCache *cachePtr, const IPosition &startTile, uInt endTile, const IPosition &startPixelInFirstTile, uInt endPixelInLastTile, uInt lineIndex)
| Access a line in a more optimized way.
char * | readTile (const char *external)
| Define the functions doing the actual read and write of the data in the tile and converting it to/from local format.
void | writeTile (char *external, const char *local)

## Static Private Member Functions

static char * | readCallBack (void *owner, const char *external)
| Define the callback functions for the BucketCache.
static void | writeCallBack (void *owner, char *external, const char *local)
static char * | initCallBack (void *owner)
static void | deleteCallBack (void *owner, char *buffer)

## Detailed Description

Tiled hypercube in a table

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Prerequisite

- TiledStMan
- ROTiledStManAccessor for a discussion of the maximum cache size
- TSMFile
- BucketCache

### Etymology

TSMCube represents a hypercube in the Tiled Storage Manager.

### Synopsis

TSMCube defines a tiled hypercube. The data is stored in a TSMFile object and accessed using a BucketCache object. The hypercube can be extensible in its last dimension to support tables with a size which is not known in advance.
Normally hypercubes share the same TSMFile object, but extensible hypercubes have their own TSMFile object (to be extensible). If the hypercolumn has multiple data columns, their cells share the same tiles. Per tile data column A appears first, thereafter B, etc..
The data in the cache is held in external format and is converted when accessed. The alternative would be to hold it in the cache in local format and convert it when read/written from the file. It was felt that the latter approach would generate more needless conversions.

The possible id and coordinate values are stored in a Record object. They are written in the main hypercube AipsIO file.

TSMCube uses the maximum cache size set for a Tiled Storage manager. The description of class ROTiledStManAccessor contains a discussion about the effect of setting the maximum cache size.

### Motivation

TSMCube encapsulates all operations on a hypercube.

Definition at line 103 of file TSMCube.h.

## Member Enumeration Documentation

## AccessType

enum casacore::TSMCube::AccessType

Define the possible access types for TSMDataColumn.

Enumerator
NoAccess |
CellAccess |
SliceAccess |
ColumnAccess |
ColumnSliceAccess |

Definition at line 107 of file TSMCube.h.

## Constructor & Destructor Documentation

## TSMCube() [1/3]

casacore::TSMCube::TSMCube | ( | TiledStMan * | stman,
|  | TSMFile * | file,
|  | const IPosition & | cubeShape,
|  | const IPosition & | tileShape,
|  | const Record & | values,
|  | Int64 | fileOffset,
|  | Bool | useDerived = False )

Construct the hypercube using the given file with the given shape.

The record contains the id and possible coordinate values.
If the cubeshape is empty, the hypercube is still undefined and can be added later with setShape. That is only used by TiledCellStMan.
The fileOffset argument is meant for class TiledFileAccess.

References cubeShape(), casacore::False, casacore::Record(), and tileShape().

Referenced by operator=(), and TSMCube().

## TSMCube() [2/3]

casacore::TSMCube::TSMCube | ( | TiledStMan * | stman,
|  | AipsIO & | ios,
|  | Bool | useDerived = False )

Reconstruct the hypercube by reading its data from the AipsIO stream.

It will link itself to the correct TSMFile. The TSMFile objects must have been reconstructed in advance.

References casacore::False.

## ~TSMCube()

virtual casacore::TSMCube::~TSMCube | ( |  | ) |

virtual

## TSMCube() [3/3]

casacore::TSMCube::TSMCube | ( | const TSMCube & |  | ) |

delete

Forbid copy constructor.

References TSMCube().

## Member Function Documentation

## accessLine()

void casacore::TSMCube::accessLine | ( | char * | section,
|  | uInt | pixelOffset,
|  | uInt | localPixelSize,
|  | Bool | writeFlag,
|  | BucketCache * | cachePtr,
|  | const IPosition & | startTile,
|  | uInt | endTile,
|  | const IPosition & | startPixelInFirstTile,
|  | uInt | endPixelInLastTile,
|  | uInt | lineIndex )

private

Access a line in a more optimized way.

## accessSection()

virtual void casacore::TSMCube::accessSection | ( | const IPosition & | start,
|  | const IPosition & | end,
|  | char * | section,
|  | uInt | colnr,
|  | uInt | localPixelSize,
|  | uInt | externalPixelSize,
|  | Bool | writeFlag )

virtual

Read or write a section in the cube.

It is assumed that the section buffer is long enough.

Reimplemented in casacore::TSMCubeBuff, and casacore::TSMCubeMMap.

## accessStrided()

virtual void casacore::TSMCube::accessStrided | ( | const IPosition & | start,
|  | const IPosition & | end,
|  | const IPosition & | stride,
|  | char * | section,
|  | uInt | colnr,
|  | uInt | localPixelSize,
|  | uInt | externalPixelSize,
|  | Bool | writeFlag )

virtual

Read or write a section in a strided way.

It is assumed that the section buffer is long enough.

Reimplemented in casacore::TSMCubeBuff, and casacore::TSMCubeMMap.

## adjustTileShape()

IPosition casacore::TSMCube::adjustTileShape | ( | const IPosition & | cubeShape,
|  | const IPosition & | tileShape ) const

protected

Adjust the tile shape to the hypercube shape.

A size of 0 gets set to 1. A tile size > cube size gets set to the cube size.

References cubeShape(), and tileShape().

## bucketSize()

uInt casacore::TSMCube::bucketSize | ( |  | ) | const

inline

Get the bucket size (bytes).

It is the length of a tile in external format.

Definition at line 428 of file TSMCube.h.

References bucketSize_p.

Referenced by calcCacheSize(), and validateCacheSize().

## cacheSize()

uInt casacore::TSMCube::cacheSize | ( |  | ) | const

Get the current cache size (in buckets).

Referenced by setCacheSize(), casacore::TSMCubeBuff::setCacheSize(), casacore::TSMCubeMMap::setCacheSize(), validateCacheSize(), and validateCacheSize().

## calcCacheSize() [1/2]

uInt casacore::TSMCube::calcCacheSize | ( | const IPosition & | cubeShape,
|  | const IPosition & | tileShape,
|  | Bool | extensible,
|  | const IPosition & | sliceShape,
|  | const IPosition & | windowStart,
|  | const IPosition & | windowLength,
|  | const IPosition & | axisPath,
|  | uInt | maxCacheSizeMiB,
|  | uInt | bucketSize )

static

References bucketSize(), cubeShape(), and tileShape().

## calcCacheSize() [2/2]

uInt casacore::TSMCube::calcCacheSize | ( | const IPosition & | sliceShape,
|  | const IPosition & | windowStart,
|  | const IPosition & | windowLength,
|  | const IPosition & | axisPath ) const

Calculate the cache size (in buckets) for the given slice and access path.

## cellShape()

IPosition casacore::TSMCube::cellShape | ( |  | ) | const

Get the shape of the data cells in the cube.

## clearCache()

void casacore::TSMCube::clearCache | ( | Bool | doFlush = True | ) |

Clear the cache, so data will be reread.

If wanted, the data is flushed before the cache is cleared.

References casacore::True.

## coordinateSize()

uInt casacore::TSMCube::coordinateSize | ( | const String & | coordinateName | ) | const

Get the size of a coordinate (i.e.

the number of values in it). If not defined, it returns zero.

References casacore::Record().

## cubeShape()

const IPosition & casacore::TSMCube::cubeShape | ( |  | ) | const

inline

Get the shape of the hypercube.

Definition at line 436 of file TSMCube.h.

References cubeShape_p.

Referenced by adjustTileShape(), calcCacheSize(), setShape(), casacore::TSMCubeBuff::setShape(), casacore::TSMCubeMMap::setShape(), TSMCube(), casacore::TSMCubeBuff::TSMCubeBuff(), and casacore::TSMCubeMMap::TSMCubeMMap().

## deleteCache()

virtual void casacore::TSMCube::deleteCache | ( |  | ) |

private virtual

Delete the cache object.

Reimplemented in casacore::TSMCubeBuff, and casacore::TSMCubeMMap.

## deleteCallBack()

void casacore::TSMCube::deleteCallBack | ( | void * | owner,
|  | char * | buffer )

static private

## emptyCache()

void casacore::TSMCube::emptyCache | ( |  | ) |

Empty the cache.

It will flush the cache as needed and remove all buckets from it resulting in a possibly large drop in memory used. It'll also clear the userSetCache_p flag.

## extend()

virtual void casacore::TSMCube::extend | ( | uInt64 | nr,
|  | const Record & | coordValues,
|  | const TSMColumn * | lastCoordColumn )

virtual

Extend the last dimension of the cube with the given number.

The record can contain the coordinates of the elements added.

Reimplemented in casacore::TSMCubeBuff, and casacore::TSMCubeMMap.

References casacore::Record().

## extendCoordinates()

void casacore::TSMCube::extendCoordinates | ( | const Record & | coordValues,
|  | const String & | coordName,
|  | uInt | length )

Extend the coordinates vector for the given coordinate to the given length with the given coordValues.

It will be initialized to zero if no coordValues are given. If the coordinate vector does not exist yet, it will be created.

References casacore::length(), and casacore::Record().

## flushCache()

virtual void casacore::TSMCube::flushCache | ( |  | ) |

virtual

Flush the data in the cache.

Reimplemented in casacore::TSMCubeBuff, and casacore::TSMCubeMMap.

## getCache()

BucketCache * casacore::TSMCube::getCache | ( |  | ) |

inline private

Get the cache object.

This will construct the cache object if not present yet.

Definition at line 421 of file TSMCube.h.

References cache_p, and makeCache().

## getLastColAccess()

TSMCube::AccessType casacore::TSMCube::getLastColAccess | ( |  | ) | const

inline

Functions for TSMDataColumn to keep track of the last type of access to a hypercube.

It uses it to determine if the cache has to be reset.

Definition at line 456 of file TSMCube.h.

References lastColAccess_p.

## getLastColSlice()

const IPosition & casacore::TSMCube::getLastColSlice | ( |  | ) | const

inline

Definition at line 460 of file TSMCube.h.

References lastColSlice_p.

## getObject()

Int casacore::TSMCube::getObject | ( | AipsIO & | ios | ) |

Get the data of the object from the AipsIO stream.

It returns the data manager sequence number, which is -1 if no file is attached to the cube (for cells without a value).

## initCallBack()

char * casacore::TSMCube::initCallBack | ( | void * | owner | ) |

static private

## isExtensible()

Bool casacore::TSMCube::isExtensible | ( |  | ) | const

Is the hypercube extensible?

## localTileLength()

uInt casacore::TSMCube::localTileLength | ( |  | ) | const

inline

Get the length of a tile (in bytes) in local format.

Definition at line 432 of file TSMCube.h.

References localTileLength_p.

## makeCache()

virtual void casacore::TSMCube::makeCache | ( |  | ) |

private virtual

Construct the cache object (if not constructed yet).

Reimplemented in casacore::TSMCubeBuff, and casacore::TSMCubeMMap.

Referenced by getCache().

## matches()

Bool casacore::TSMCube::matches | ( | const PtrBlock< TSMColumn * > & | idColSet,
|  | const Record & | idValues )

Test if the id values match.

References casacore::Record().

## operator=()

TSMCube & casacore::TSMCube::operator= | ( | const TSMCube & |  | ) |

delete

Forbid assignment.

References TSMCube().

## putObject()

void casacore::TSMCube::putObject | ( | AipsIO & | ios | ) |

Put the data of the object into the AipsIO stream.

## readCallBack()

char * casacore::TSMCube::readCallBack | ( | void * | owner,
|  | const char * | external )

static private

Define the callback functions for the BucketCache.

## readTile()

char * casacore::TSMCube::readTile | ( | const char * | external | ) |

private

Define the functions doing the actual read and write of the data in the tile and converting it to/from local format.

## resizeTileSections()

void casacore::TSMCube::resizeTileSections | ( |  | ) |

protected

Resize the IPosition member variables used in accessSection() if nrdim_p changes value.

## resync()

virtual void casacore::TSMCube::resync | ( | AipsIO & | ios | ) |

virtual

Resync the object with the data file.

It reads the object, and adjusts the cache.

## resyncCache()

virtual void casacore::TSMCube::resyncCache | ( |  | ) |

private virtual

Resync the cache object.

Reimplemented in casacore::TSMCubeBuff, and casacore::TSMCubeMMap.

## rwValueRecord()

Record & casacore::TSMCube::rwValueRecord | ( |  | ) |

inline

Definition at line 448 of file TSMCube.h.

References casacore::Record(), and values_p.

## setCacheSize() [1/2]

virtual void casacore::TSMCube::setCacheSize | ( | const IPosition & | sliceShape,
|  | const IPosition & | windowStart,
|  | const IPosition & | windowLength,
|  | const IPosition & | axisPath,
|  | Bool | forceSmaller,
|  | Bool | userSet )

virtual

Set the cache size for the given slice and access path.

Reimplemented in casacore::TSMCubeBuff, and casacore::TSMCubeMMap.

## setCacheSize() [2/2]

virtual void casacore::TSMCube::setCacheSize | ( | uInt | cacheSize,
|  | Bool | forceSmaller,
|  | Bool | userSet )

virtual

Resize the cache object.

If forceSmaller is False, the cache will only be resized when it grows. If the given size exceeds the maximum size with more than 10%, the maximum size will be used. The cacheSize has to be given in buckets.
The flag userSet inidicates if the cache size is set by the user (by an Accessor object) or automatically (by TSMDataColumn).

Reimplemented in casacore::TSMCubeBuff, and casacore::TSMCubeMMap.

References cacheSize().

## setLastColAccess()

void casacore::TSMCube::setLastColAccess | ( | TSMCube::AccessType | type | ) |

inline

Definition at line 464 of file TSMCube.h.

References lastColAccess_p.

## setLastColSlice()

void casacore::TSMCube::setLastColSlice | ( | const IPosition & | slice | ) |

inline

Definition at line 468 of file TSMCube.h.

References lastColSlice_p, and casacore::IPosition::nelements().

## setShape()

virtual void casacore::TSMCube::setShape | ( | const IPosition & | cubeShape,
|  | const IPosition & | tileShape )

virtual

Set the hypercube shape.

This is only possible if the shape was not defined yet.

Reimplemented in casacore::TSMCubeBuff, and casacore::TSMCubeMMap.

References cubeShape(), and tileShape().

## setup()

void casacore::TSMCube::setup | ( |  | ) |

protected

Initialize the various variables.

## setupNrTiles()

void casacore::TSMCube::setupNrTiles | ( |  | ) |

protected

## showCacheStatistics()

virtual void casacore::TSMCube::showCacheStatistics | ( | ostream & | os | ) | const

virtual

Show the cache statistics.

Reimplemented in casacore::TSMCubeBuff, and casacore::TSMCubeMMap.

## tileShape()

const IPosition & casacore::TSMCube::tileShape | ( |  | ) | const

inline

Get the shape of the tiles.

Definition at line 440 of file TSMCube.h.

References tileShape_p.

Referenced by adjustTileShape(), calcCacheSize(), setShape(), casacore::TSMCubeBuff::setShape(), casacore::TSMCubeMMap::setShape(), TSMCube(), casacore::TSMCubeBuff::TSMCubeBuff(), and casacore::TSMCubeMMap::TSMCubeMMap().

## userSetCache()

Bool casacore::TSMCube::userSetCache | ( |  | ) | const

inline

Determine if the user set the cache size (using setCacheSize).

Definition at line 452 of file TSMCube.h.

References userSetCache_p.

## validateCacheSize() [1/2]

uInt casacore::TSMCube::validateCacheSize | ( | uInt | cacheSize | ) | const

Validate the cache size (in buckets).

This means it will return the given cache size (in buckets) if smaller than the maximum cache size (given in MiB). Otherwise the maximum is returned.

References cacheSize().

## validateCacheSize() [2/2]

uInt casacore::TSMCube::validateCacheSize | ( | uInt | cacheSize,
|  | uInt | maxSizeMiB,
|  | uInt | bucketSize )

static

References bucketSize(), and cacheSize().

## valueRecord()

const Record & casacore::TSMCube::valueRecord | ( |  | ) | const

inline

Get the record containing the id and coordinate values.

It is used by TSMIdColumn and TSMCoordColumn.

Definition at line 444 of file TSMCube.h.

References casacore::Record(), and values_p.

## writeCallBack()

void casacore::TSMCube::writeCallBack | ( | void * | owner,
|  | char * | external,
|  | const char * | local )

static private

## writeTile()

void casacore::TSMCube::writeTile | ( | char * | external,
|  | const char * | local )

private

## Member Data Documentation

## bucketSize_p

uInt casacore::TSMCube::bucketSize_p

protected

The bucket size in bytes (is equal to tile size in bytes).

Definition at line 390 of file TSMCube.h.

Referenced by bucketSize().

## cache_p

BucketCache* casacore::TSMCube::cache_p

protected

The bucket cache.

Definition at line 394 of file TSMCube.h.

Referenced by getCache().

## cachedTile_p

char* casacore::TSMCube::cachedTile_p

protected

Definition at line 353 of file TSMCube.h.

## cubeShape_p

IPosition casacore::TSMCube::cubeShape_p

protected

The shape of the hypercube.

Definition at line 368 of file TSMCube.h.

Referenced by cubeShape().

## endPixelInFirstTile_p

IPosition casacore::TSMCube::endPixelInFirstTile_p

protected

Last pixel in first tile.

Definition at line 414 of file TSMCube.h.

## endPixelInLastTile_p

IPosition casacore::TSMCube::endPixelInLastTile_p

protected

Last pixel in last tile.

Definition at line 416 of file TSMCube.h.

## endTile_p

IPosition casacore::TSMCube::endTile_p

protected

Last tile needed.

Definition at line 410 of file TSMCube.h.

## expandedTileShape_p

TSMShape casacore::TSMCube::expandedTileShape_p

protected

Precomputed tileShape information.

Definition at line 374 of file TSMCube.h.

## expandedTilesPerDim_p

TSMShape casacore::TSMCube::expandedTilesPerDim_p

protected

Precomputed tilesPerDim information.

Definition at line 376 of file TSMCube.h.

## extensible_p

Bool casacore::TSMCube::extensible_p

protected

Is the hypercube extensible?

Definition at line 362 of file TSMCube.h.

## externalOffset_p

Block<uInt> casacore::TSMCube::externalOffset_p

protected

Offset for each data column in a tile (in external format).

Definition at line 386 of file TSMCube.h.

## fileOffset_p

Int64 casacore::TSMCube::fileOffset_p

protected

Offset in the TSMFile object where the data of this hypercube starts.

Definition at line 384 of file TSMCube.h.

## filePtr_p

TSMFile* casacore::TSMCube::filePtr_p

protected

Pointer to the TSMFile object holding the data.

Definition at line 382 of file TSMCube.h.

## lastColAccess_p

AccessType casacore::TSMCube::lastColAccess_p

protected

Was the last column access to a cell, slice, or column?

Definition at line 398 of file TSMCube.h.

Referenced by getLastColAccess(), and setLastColAccess().

## lastColSlice_p

IPosition casacore::TSMCube::lastColSlice_p

protected

The slice shape of the last column access to a slice.

Definition at line 400 of file TSMCube.h.

Referenced by getLastColSlice(), and setLastColSlice().

## localOffset_p

Block<uInt> casacore::TSMCube::localOffset_p

protected

Offset for each data column in a tile (in local format).

Definition at line 388 of file TSMCube.h.

## localTileLength_p

uInt casacore::TSMCube::localTileLength_p

protected

The tile size in bytes in local format.

Definition at line 392 of file TSMCube.h.

Referenced by localTileLength().

## nrdim_p

uInt casacore::TSMCube::nrdim_p

protected

Dimensionality of the hypercube.

Definition at line 364 of file TSMCube.h.

## nrTiles_p

uInt casacore::TSMCube::nrTiles_p

protected

Number of tiles in the hypercube.

Definition at line 366 of file TSMCube.h.

## nrTileSection_p

IPosition casacore::TSMCube::nrTileSection_p

protected

IPosition variables used in accessSection(); declared here as member variables to avoid significant construction and desctruction overhead if they are local to accessSection() #tiles needed for the section.

Definition at line 406 of file TSMCube.h.

## nrTilesSubCube_p

uInt casacore::TSMCube::nrTilesSubCube_p

protected

Number of tiles in all but last dimension (used when extending).

Definition at line 378 of file TSMCube.h.

## startPixelInFirstTile_p

IPosition casacore::TSMCube::startPixelInFirstTile_p

protected

First pixel in first tile.

Definition at line 412 of file TSMCube.h.

## startTile_p

IPosition casacore::TSMCube::startTile_p

protected

First tile needed.

Definition at line 408 of file TSMCube.h.

## stmanPtr_p

TiledStMan* casacore::TSMCube::stmanPtr_p

protected

Pointer to the parent storage manager.

Definition at line 356 of file TSMCube.h.

## tileShape_p

IPosition casacore::TSMCube::tileShape_p

protected

The shape of the tiles in the hypercube.

Definition at line 370 of file TSMCube.h.

Referenced by tileShape().

## tileSize_p

uInt casacore::TSMCube::tileSize_p

protected

The tilesize in bytes.

Definition at line 380 of file TSMCube.h.

## tilesPerDim_p

IPosition casacore::TSMCube::tilesPerDim_p

protected

The number of tiles in each hypercube dimension.

Definition at line 372 of file TSMCube.h.

## useDerived_p

Bool casacore::TSMCube::useDerived_p

protected

Is the class used directly or only by a derived class only?

Definition at line 358 of file TSMCube.h.

## userSetCache_p

Bool casacore::TSMCube::userSetCache_p

protected

Did the user set the cache size?

Definition at line 396 of file TSMCube.h.

Referenced by userSetCache().

## values_p

Record casacore::TSMCube::values_p

protected

The values of the possible id and coordinate columns.

Definition at line 360 of file TSMCube.h.

Referenced by rwValueRecord(), and valueRecord().

The documentation for this class was generated from the following file:

- tables/DataMan/TSMCube.h